Index: trunk/README.md
===================================================================
--- trunk/README.md	(revision 140)
+++ trunk/README.md	(revision 142)
@@ -1,13 +1,9 @@
-# Morty
+# Yukari
 
-[![Build Status](https://travis-ci.org/asciimoo/morty.svg)](https://travis-ci.org/asciimoo/morty)
-[![License: AGPL v3](https://img.shields.io/badge/License-AGPL%20v3-blue.svg)](https://www.gnu.org/licenses/agpl-3.0)
-[![Docker Pulls](https://img.shields.io/docker/pulls/dalf/morty)](https://hub.docker.com/r/dalf/morty)
+Web content sanitizer proxy as a service, fork of [MortyProxy](https://github.com/asciimoo/morty) with some suggestions from the issue tracker applied, named after [Yes, that Gap Youkai](https://en.touhouwiki.net/wiki/Yukari_Yakumo)
 
-Web content sanitizer proxy as a service
+Yukari rewrites web pages to exclude malicious HTML tags and attributes. It also replaces external resource references to prevent third party information leaks.
 
-Morty rewrites web pages to exclude malicious HTML tags and attributes. It also replaces external resource references to prevent third party information leaks.
-
-The main goal of morty is to provide a result proxy for [searx](https://asciimoo.github.com/searx/), but it can be used as a standalone sanitizer service too.
+The main goal of yukari is to provide a result proxy for [searx](https://asciimoo.github.com/searx/), but it can be used as a standalone sanitizer service too.
 
 Features:
@@ -27,6 +23,6 @@
 
 ```
-$ go install github.com/asciimoo/morty@latest
-$ "$GOPATH/bin/morty" --help
+$ go install marisa.chaotic.ninja/yukari@latest
+$ "$GOPATH/bin/yukari" --help
 ```
 
@@ -39,5 +35,5 @@
         Follow HTTP GET redirect
   -hashparam string
-        User-defined requesting string HASH parameter name (ie: '/?hash=...' or '/?h=...') (default "mortyhash")
+        User-defined requesting string HASH parameter name (ie: '/?hash=...' or '/?h=...') (default "yukarihash")
   -ipv6
         Allow IPv6 HTTP requests (default true)
@@ -55,5 +51,5 @@
         Request timeout (default 5)
   -urlparam string
-        User-defined requesting string URL parameter name (ie: '/?url=...' or '/?u=...') (default "mortyurl")
+        User-defined requesting string URL parameter name (ie: '/?url=...' or '/?u=...') (default "yukariurl")
   -version
         Show version
@@ -62,26 +58,15 @@
 ### Environment variables
 
-Morty can additionally be configured using the following environment variables:
-- `MORTY_ADDRESS`: Listen address (default to `127.0.0.1:3000`)
-- `MORTY_KEY`: HMAC url validation key (base64 encoded) to prevent direct URL opening. Leave blank to disable validation. Use `openssl rand -base64 33` to generate.
-- `MORTY_URL_PARAM`: User-defined requesting string URL parameter name (ie: `/?url=...` or `/?u=...`) (default `mortyurl`)
-- `MORTY_HASH_PARAM`: User-defined requesting string HASH parameter name (ie: `/?hash=...` or `/?h=...`) (default `mortyhash`)
+Yukari can additionally be configured using the following environment variables:
+- `YUKARI_ADDRESS`: Listen address (default to `127.0.0.1:3000`)
+- `YUKARI_KEY`: HMAC url validation key (base64 encoded) to prevent direct URL opening. Leave blank to disable validation. Use `openssl rand -base64 33` to generate.
+- `YUKARI_URL_PARAM`: User-defined requesting string URL parameter name (ie: `/?url=...` or `/?u=...`) (default `yukariurl`)
+- `YUKARI_HASH_PARAM`: User-defined requesting string HASH parameter name (ie: `/?hash=...` or `/?h=...`) (default `yukarihash`)
 - `DEBUG`: Enable/disable proxy and redirection logs (default to `true`). Set to `false` to disable.
-
-### Docker
-
-```
-docker run -e DEBUG=false -e MORTY_ADDRESS=0.0.0.0:3000 dalf/morty
-```
-
-```
-docker run -e DEBUG=false dalf/morty -listen 0.0.0.0:3000
-```
-
 
 ### Test
 
 ```
-$ cd "$GOPATH/src/github.com/asciimoo/morty"
+$ cd "$GOPATH/src/marisa.chaotic.ninja/yukari"
 $ go test
 ```
@@ -91,5 +76,5 @@
 
 ```
-$ cd "$GOPATH/src/github.com/asciimoo/morty"
+$ cd "$GOPATH/src/marisa.chaotic.ninja/yukari"
 $ go test -benchmem -bench .
 ```
@@ -97,4 +82,3 @@
 
 ## Bugs
-
-Bugs or suggestions? Visit the [issue tracker](https://github.com/asciimoo/morty/issues).
+Bugs or suggestions? Visit the [issue tracker](https://git.chaotic.ninja/yakumo.izuru/yukari/issues).